org.apache.http.nio.protocol

## Interface HttpAsyncRequestProducer

- All Superinterfaces:
    AutoCloseable, Closeable
  All Known Subinterfaces:
    HttpAsyncRequestExecutionHandler<T>
  All Known Implementing Classes:
    BasicAsyncRequestExecutionHandler, BasicAsyncRequestProducer

      public interface HttpAsyncRequestProducer
      extends Closeable

  `HttpAsyncRequestProducer` is a callback interface whose methods get invoked to generate an HTTP request message and to stream message content to a non-blocking HTTP connection.

  Repeatable request producers capable of generating the same request message more than once can be reset to their initial state by calling the `resetRequest()` method, at which point request producers are expected to release currently allocated resources that are no longer needed or re-acquire resources needed to repeat the process.
  Since:
    4.2

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `failed(Exception ex)` Invoked to signal that the response processing terminated abnormally.
    `HttpRequest` | `generateRequest()` Invoked to generate a HTTP request message head.
    `HttpHost` | `getTarget()` Invoked to obtain the request target host.
    `boolean` | `isRepeatable()` Determines whether or not this producer is capable of producing HTTP request messages more than once.
    `void` | `produceContent(ContentEncoder encoder, IOControl ioctrl)` Invoked to write out a chunk of content to the `ContentEncoder`.
    `void` | `requestCompleted(HttpContext context)` Invoked to signal that the request has been fully written out.
    `void` | `resetRequest()` Invoked to reset the producer to its initial state.

    - ### Methods inherited from interface java.io.Closeable

      `close`

- - ### Method Detail

    - #### getTarget

          HttpHost getTarget()

      Invoked to obtain the request target host.

    - #### generateRequest

          HttpRequest generateRequest()
                                      throws IOException,
                                             HttpException

      Invoked to generate a HTTP request message head. The message is expected to implement the `HttpEntityEnclosingRequest` interface if it is to enclose a content entity. The `produceContent( ContentEncoder, IOControl)` method will not be invoked if `HttpEntityEnclosingRequest.getEntity()` returns `null`.
      Returns:
        HTTP request message.
      Throws:
        `HttpException` - in case of HTTP protocol violation
        `IOException` - in case of an I/O error

    - #### produceContent

          void produceContent(ContentEncoder encoder,
                            IOControl ioctrl)
                              throws IOException

      Invoked to write out a chunk of content to the `ContentEncoder`. The `IOControl` interface can be used to suspend output event notifications if the producer is temporarily unable to produce more content.

      When all content is finished, the producer MUST call `ContentEncoder.complete()`. Failure to do so may cause the entity to be incorrectly delimited.

      Please note that the `ContentEncoder` object is not thread-safe and should only be used within the context of this method call. The `IOControl` object can be shared and used on other thread to resume output event notifications when more content is made available.
      Parameters:
        `encoder` - content encoder.
        `ioctrl` - I/O control of the underlying connection.
      Throws:
        `IOException` - in case of an I/O error

    - #### requestCompleted

          void requestCompleted(HttpContext context)

      Invoked to signal that the request has been fully written out.
      Parameters:
        `context` - HTTP context

    - #### failed

          void failed(Exception ex)

      Invoked to signal that the response processing terminated abnormally.
      Parameters:
        `ex` - exception

    - #### isRepeatable

          boolean isRepeatable()

      Determines whether or not this producer is capable of producing HTTP request messages more than once.

    - #### resetRequest

          void resetRequest()
                            throws IOException

      Invoked to reset the producer to its initial state. Repeatable request producers are expected to release currently allocated resources that are no longer needed or re-acquire resources needed to repeat the process.
      Throws:
        `IOException` - in case of an I/O error

Copyright © 2005–2013 The Apache Software Foundation. All rights reserved.